function [xEst,ZMean,xTrue]=KalmanSkalarXValtozoR(F,B,Q,H,Rfile,u)

s=['load ' Rfile '.mat'];
eval(s);

% A becslsi lpsek szma
%N=1000;
N=max(size(u));   % a bemeneti jel hossza N, amintk szma

%A szenzorok szma
NS=max(size(H));

if N~=size(R,1), disp('hibs Rfile: a mtrixok szma meg kell egyezzen a bemenet hosszval'),return,end
if NS~=size(R,2), disp('hibs Rfile: a mtrixok sorainak szma meg kell egyezzen a szenzorok szmval'),return,end
if NS~=size(R,2), disp('hibs Rfile: a mtrixok oszlopainak szma meg kell egyezzen a szenzorok szmval'),return,end

%% az llapotegyenlet
% x(k)=F*x(k-1)+B*u(k)+v;
% v=0???,  Q=0 kov mtrix

%F=1;
%B=0.1;
%Q=0.0001;
%% bemeneti jel
%u=ones(1,N);    %bemeneti jel
%u(1,floor(N/4):floor(N/2))=0;

%% valdi ismeretlen jel (llapotvltoz) sorozat - ZAJ nlkl!!!

xTrue=zeros(1,N);
xTrue(1)=0;
for kk=2:N
    xTrue(kk)=F*xTrue(kk-1)+B*u(kk);
end

%% megfigyelsi egyenlet

%z(k)=H*x(k)+w
%mrsi zaj
%H=ones(3,1);
%SigmaM=1;
% R-et az Rfile-bol olvassuk be!!!!
% R=SigmaM^2*eye(NS,NS);
%z=H*xTrue+SigmaM*randn(NS,N);
z=zeros(NS,N);

%% inicializls
PPred=zeros(1,N);
PEst=zeros(1,N);

xPred=zeros(1,N);
xEst=zeros(1,N);

K=zeros(NS,N);
%% a Kalman szuro
RAkt=zeros(NS,NS);
for k=2:N
    xPred(1,k)=F*xEst(1,k-1)+B*u(k);
    PPred(1,k)=F*PEst(1,k-1)*F'+Q;
    for jj=1:NS
        RAkt(jj,:)=R(k,jj,1:NS);
    end
    K(:,k)=PPred(k)*H'*inv(H*PPred(k)*H'+RAkt);
    zAkt=H*xTrue(k)+sqrt(diag(RAkt)).*randn(NS,1);
    z(:,k)=zAkt;
    xEst(k)=xPred(k)+K(:,k)'*(zAkt-H*xPred(k));
    PEst(1,k)=(1-K(:,k)'*H)*PPred(1,k);
end

tt=1:N;
ZMean=mean(z);
figure(1),plot(tt,xEst,'b',tt,z(1,:),'g',tt,ZMean,'m',tt,xTrue,'r')
title('xEst - kk, z(1,:) - zld, a 3 mrs tlaga - magenta, xTrue - piros')

figure(2),plot(tt,K(1,:))
title('A Kalman erosites az elso mrsi komponensre')

figure(3),plot(tt,PEst)
title('az llapotbecsls kovariancijnak becslse')